package testnfc;

import utildll.*;

public class Wrp_Kernel32 {
	static final int CHARSET = Arg.ANSI;
	static final String KERNEL32_DLL_NAME = "kernel32";
	private String[] strFncName = {
			"GetModuleHandleA"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
	IDX_GetModuleHandle = 0;
	private long hMod = 0;
	
	Wrp_Kernel32() {
		Arg_GetModuleHandle agmh = new Arg_GetModuleHandle(KERNEL32_DLL_NAME);
		
		hMod = JInvoker.callLongProc("GetModuleHandle", "kernel32", agmh);
		
		System.out.println("GetModuleHandle rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(agmh.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " FncName: " + strFncName[i]);
		}
	}

	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	
	/*
	HMODULE GetModuleHandle(
	  LPCTSTR lpModuleName   // W[
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetModuleHandle extends Arg_property {
		private @_Const String lpModuleName;

		Arg_GetModuleHandle(String lpModuleName) {
			this.lpModuleName = lpModuleName;
		}
	}

	long GetModuleHandle(String lpModuleName) throws Exception_Win64 {
		Arg_GetModuleHandle agmh = new Arg_GetModuleHandle(lpModuleName);

		long lngRtn = JInvoker.callLongProcAddress(lngFncAdrs[IDX_GetModuleHandle], agmh);
		
		System.out.println("GetModuleHandle rtn: " + Long.toHexString(lngRtn)
				+ " LastError: " + Integer.toString(agmh.getLastError()));
		
		if (agmh.getLastError() != 0) throw new Exception_Win64("GetModuleHandle");
		if (lngRtn == 0) throw new Exception_Win64("GetModuleHandle");
		
		return lngRtn;
	}
	
	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}

}
