package testnfc;

import utildll.*;

class Wrp_felica_nfc_library {
	static final int CHARSET = Arg.ANSI;
	static final String NFC_DLL_NAME = "felica_nfc_library";
	private String[] strFncName = {
			"felicalib_nfc_close",
			"felicalib_nfc_deselect_device",
			"felicalib_nfc_get_last_error",
			"felicalib_nfc_get_timeout",
			"felicalib_nfc_initialize",
			"felicalib_nfc_open",
			"felicalib_nfc_poll_and_start_dev_access",
			"felicalib_nfc_select_device",
			"felicalib_nfc_set_pnp_callback_parameters",
			"felicalib_nfc_set_poll_callback_parameters",
			"felicalib_nfc_set_timeout",
			"felicalib_nfc_set_watching_interval",
			"felicalib_nfc_start_dev_access",
			"felicalib_nfc_start_logging",
			"felicalib_nfc_start_plug_and_play",
			"felicalib_nfc_start_poll_mode",
			"felicalib_nfc_stop_dev_access",
			"felicalib_nfc_stop_logging",
			"felicalib_nfc_stop_plug_and_play",
			"felicalib_nfc_stop_poll_mode",
			"felicalib_nfc_thru",
			"felicalib_nfc_uninitialize"};
	private long[] lngFncAdrs = new long[strFncName.length];
	private final int 
			IDX_felicalib_nfc_close = 0,
			IDX_felicalib_nfc_deselect_device = 1,
			IDX_felicalib_nfc_get_last_error = 2,
			IDX_felicalib_nfc_get_timeout = 3,
			IDX_felicalib_nfc_initialize = 4,
			IDX_felicalib_nfc_open = 5,
			IDX_felicalib_nfc_poll_and_start_dev_access = 6,
			IDX_felicalib_nfc_select_device = 7,
			IDX_felicalib_nfc_set_pnp_callback_parameters = 8,
			IDX_felicalib_nfc_set_poll_callback_parameters = 9,
			IDX_felicalib_nfc_set_timeout = 10,
			IDX_felicalib_nfc_set_watching_interval = 11,
			IDX_felicalib_nfc_start_dev_access = 12,
			IDX_felicalib_nfc_start_logging = 13,
			IDX_felicalib_nfc_start_plug_and_play = 14,
			IDX_felicalib_nfc_start_poll_mode = 15,
			IDX_felicalib_nfc_stop_dev_access = 16,
			IDX_felicalib_nfc_stop_logging = 17,
			IDX_felicalib_nfc_stop_plug_and_play = 18,
			IDX_felicalib_nfc_stop_poll_mode = 19,
			IDX_felicalib_nfc_thru = 20,
			IDX_felicalib_nfc_uninitialize = 21;
	private long hMod = 0;
	
	Wrp_felica_nfc_library() {
		Arg_LoadLibrary all = new Arg_LoadLibrary(NFC_DLL_NAME);
		
		hMod = JInvoker.callLongProc("LoadLibrary", "kernel32", all);
		
		System.out.println("LoadLibrary rtn: " + Long.toHexString(hMod)
				+ " LastError: " + Integer.toString(all.getLastError()));
		
		for (int i = 0; i < strFncName.length; i++) {
			Arg_GetProcAddress agpa = new Arg_GetProcAddress(hMod, strFncName[i]);
			
			lngFncAdrs[i] = JInvoker.callLongProc("GetProcAddress", "kernel32", agpa);
			
			System.out.println("GetProcAddress rtn: " + Long.toHexString(lngFncAdrs[i])
					+ " LastError: " + Integer.toString(agpa.getLastError())
					+ " FncName: " + strFncName[i]);
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}
	
	/*
	 bool felicalib_nfc_close(void);
	 */
	class Arg_felicalib_nfc_close extends Arg_property {
	}
	
	boolean felicalib_nfc_close() throws Exception_NFC {
		Arg_felicalib_nfc_close afnc = new Arg_felicalib_nfc_close();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_close], afnc);
		
		System.out.println("felicalib_nfc_close rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnc.getLastError()));
		
		if (afnc.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_close");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_close");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_deselect_device(void);
	 */
	class Arg_felicalib_nfc_deselect_device extends Arg_property {
	}
	
	boolean felicalib_nfc_deselect_device() throws Exception_NFC {
		Arg_felicalib_nfc_deselect_device afndd = new Arg_felicalib_nfc_deselect_device();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_deselect_device], afndd);
		
		System.out.println("felicalib_nfc_deselect_device rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afndd.getLastError()));
		
		if (afndd.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_deselect_device");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_deselect_device");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_get_last_error(
	 	unsigned long *error_info
	 );
	 */
	class Arg_felicalib_nfc_get_last_error extends Arg_property {
		private int[] error_info;
		
		Arg_felicalib_nfc_get_last_error(int[] error_info) {
			this.error_info = error_info;
		}
	}
	
	boolean felicalib_nfc_get_last_error(int[] error_info) throws Exception_NFC {
		Arg_felicalib_nfc_get_last_error afngle = new Arg_felicalib_nfc_get_last_error(error_info);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_get_last_error], afngle);
		
		System.out.println("felicalib_nfc_get_last_error rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afngle.getLastError()));
		
		if (afngle.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_get_last_error");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_get_last_error");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_get_timeout(
	 	unsigned long *timeout
	 );
	 */
	class Arg_felicalib_nfc_get_timeout extends Arg_property {
		private int[] timeout;
		
		Arg_felicalib_nfc_get_timeout(int[] timeout) {
			this.timeout = timeout;
		}
	}
	
	boolean felicalib_nfc_get_timeout(int[] timeout) throws Exception_NFC {
		Arg_felicalib_nfc_get_timeout afngt = new Arg_felicalib_nfc_get_timeout(timeout);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_get_timeout], afngt);
		
		System.out.println("felicalib_nfc_get_timeout rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afngt.getLastError()));
		
		if (afngt.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_get_timeout");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_get_timeout");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_initialize(void);
	 */
	class Arg_felicalib_nfc_initialize extends Arg_property {
	}
	
	boolean felicalib_nfc_initialize() throws Exception_NFC {
		Arg_felicalib_nfc_initialize afni = new Arg_felicalib_nfc_initialize();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_initialize], afni);
		
		System.out.println("felicalib_nfc_initialize rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afni.getLastError()));
		
		if (afni.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_initialize");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_initialize");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_open(
	 	char *port_name
	 );
	 */
	@_CharSet(Arg.ANSI)
	class Arg_felicalib_nfc_open extends Arg_property {
		private @_Const String port_name;
		
		Arg_felicalib_nfc_open(String port_name) {
			this.port_name = port_name;
		}
	}
	
	boolean felicalib_nfc_open(String port_name) throws Exception_NFC {
		Arg_felicalib_nfc_open afno = new Arg_felicalib_nfc_open(port_name);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_open], afno);
		
		System.out.println("felicalib_nfc_open rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afno.getLastError()));
		
		if (afno.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_open");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_open");
		
		return bytRtn != 0;
	}

	/*
	bool felicalib_nfc_poll_and_start_dev_access(
		unsigned long target_device,
		unsigned long timeout,
		DEVICE_INFO** device_info
	);
	 */
	class Arg_felicalib_nfc_poll_and_start_dev_access extends Arg_property {
		private int target_device;
		private int timeout;
		private Struct_REF_DEVICE_INFO ppdevice_info = new Struct_REF_DEVICE_INFO();
		
		Arg_felicalib_nfc_poll_and_start_dev_access(int target_device, int timeout) {
			this.target_device = target_device;
			this.timeout = timeout;
		}
	}
	
	class Struct_REF_DEVICE_INFO {
		Struct_DEVICE_INFO pdevice_info = null;
	}
	
	Struct_DEVICE_INFO felicalib_nfc_poll_and_start_dev_access(int target_device, int timeout)
			throws Exception_NFC {
		Arg_felicalib_nfc_poll_and_start_dev_access afnpasda 
				= new Arg_felicalib_nfc_poll_and_start_dev_access(target_device, timeout);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_poll_and_start_dev_access], afnpasda);
		
		System.out.println("felicalib_nfc_poll_and_start_dev_access rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnpasda.getLastError()));
		
		if (afnpasda.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_poll_and_start_dev_access");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_poll_and_start_dev_access");
		
		return afnpasda.ppdevice_info.pdevice_info;
	}

	/*
	 bool felicalib_nfc_select_device(void);
	 */
	class Arg_felicalib_nfc_select_device extends Arg_property {
	}
	
	boolean felicalib_nfc_select_device() throws Exception_NFC {
		Arg_felicalib_nfc_select_device afnsd = new Arg_felicalib_nfc_select_device();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_select_device], afnsd);
		
		System.out.println("felicalib_nfc_select_device rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnsd.getLastError()));
		
		if (afnsd.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_select_device");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_select_device");
		
		return bytRtn != 0;
	}

	/*
	bool felicalib_nfc_set_poll_callback_parameters(
		HWND handle,
		const unsigned char *msg_str_of_find,
		const unsigned char *msg_str_of_enable
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_felicalib_nfc_set_poll_callback_parameters extends Arg_property {
		private long handle;
		private @_Const String msg_str_of_find;
		private @_Const String msg_str_of_enable;
		
		Arg_felicalib_nfc_set_poll_callback_parameters(long handle, String msg_str_of_find,
				String msg_str_of_enable) {
			this.handle = handle;
			this.msg_str_of_find = msg_str_of_find;
			this.msg_str_of_enable = msg_str_of_enable;
		}
	}
	
	boolean felicalib_nfc_set_poll_callback_parameters(long handle, String msg_str_of_find,
			String msg_str_of_enable) throws Exception_NFC {
		Arg_felicalib_nfc_set_poll_callback_parameters afnspcp 
			= new Arg_felicalib_nfc_set_poll_callback_parameters(handle, msg_str_of_find, msg_str_of_enable);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_set_poll_callback_parameters], afnspcp);
		
		System.out.println("felicalib_nfc_set_poll_callback_parameters rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnspcp.getLastError()));
		
		if (afnspcp.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_set_poll_callback_parameters");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_set_poll_callback_parameters");
		
		return bytRtn != 0;
	}
	
	/*
	 bool felicalib_nfc_set_timeout(
	 	unsigned long timeout
	 );
	 */
	class Arg_felicalib_nfc_set_timeout extends Arg_property {
		private int timeout;
		
		Arg_felicalib_nfc_set_timeout(int timeout) {
			this.timeout = timeout;
		}
	}
	
	boolean felicalib_nfc_set_timeout(int timeout) throws Exception_NFC {
		Arg_felicalib_nfc_set_timeout afnst = new Arg_felicalib_nfc_set_timeout(timeout);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_set_timeout], afnst);
		
		System.out.println("felicalib_nfc_set_timeout rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnst.getLastError()));
		
		if (afnst.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_set_timeout");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_set_timeout");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_start_dev_access(
	 	unsigned long target_number
	 );
	 */
	class Arg_felicalib_nfc_start_dev_access extends Arg_property {
		private int target_number;
		
		Arg_felicalib_nfc_start_dev_access(int target_number) {
			this.target_number = target_number;
		}
	}
	
	boolean felicalib_nfc_start_dev_access(int target_number) throws Exception_NFC {
		Arg_felicalib_nfc_start_dev_access afnsda = new Arg_felicalib_nfc_start_dev_access(target_number);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_start_dev_access], afnsda);
		
		System.out.println("felicalib_nfc_start_dev_access rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnsda.getLastError()));
		
		if (afnsda.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_start_dev_access");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_start_dev_access");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_start_logging(
	 	const char *filename
	 );
	 */
	@_CharSet(Arg.ANSI)
	class Arg_felicalib_nfc_start_logging extends Arg_property {
		private @_Const String filename;
		
		Arg_felicalib_nfc_start_logging(String filename) {
			this.filename = filename;
		}
	}
	
	boolean felicalib_nfc_start_logging(String filename) throws Exception_NFC {
		Arg_felicalib_nfc_start_logging afnsl = new Arg_felicalib_nfc_start_logging(filename);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_start_logging], afnsl);
		
		System.out.println("felicalib_nfc_start_logging rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnsl.getLastError()));
		
		if (afnsl.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_start_logging");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_start_logging");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_start_poll_mode(
	 	unsigned long target_device
	 );
	 */
	class Arg_felicalib_nfc_start_poll_mode extends Arg_property {
		private int target_device;
		
		Arg_felicalib_nfc_start_poll_mode(int target_device) {
			this.target_device = target_device;
		}
	}
	
	boolean felicalib_nfc_start_poll_mode(int target_device) throws Exception_NFC {
		Arg_felicalib_nfc_start_poll_mode afnspm = new Arg_felicalib_nfc_start_poll_mode(target_device);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_start_poll_mode], afnspm);
		
		System.out.println("felicalib_nfc_start_poll_mode rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnspm.getLastError()));
		
		if (afnspm.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_start_poll_mode");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_start_poll_mode");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_stop_dev_access(
	 	unsigned long stop_mode
	 );
	 */
	class Arg_felicalib_nfc_stop_dev_access extends Arg_property {
		private int stop_mode;
		
		Arg_felicalib_nfc_stop_dev_access(int stop_mode) {
			this.stop_mode = stop_mode;
		}
	}
	
	boolean felicalib_nfc_stop_dev_access(int stop_mode) throws Exception_NFC {
		Arg_felicalib_nfc_stop_dev_access afnsda = new Arg_felicalib_nfc_stop_dev_access(stop_mode);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_stop_dev_access], afnsda);
		
		System.out.println("felicalib_nfc_stop_dev_access rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnsda.getLastError()));
		
		if (afnsda.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_stop_dev_access");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_stop_dev_access");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_stop_logging(void);
	 */
	class Arg_felicalib_nfc_stop_logging extends Arg_property {
	}
	
	boolean felicalib_nfc_stop_logging() throws Exception_NFC {
		Arg_felicalib_nfc_stop_logging afnsl = new Arg_felicalib_nfc_stop_logging();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_stop_logging], afnsl);
		
		System.out.println("felicalib_nfc_stop_logging rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnsl.getLastError()));
		
		if (afnsl.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_stop_logging");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_stop_logging");
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_stop_poll_mode(void);
	 */
	class Arg_felicalib_nfc_stop_poll_mode extends Arg_property {
	}
	
	boolean felicalib_nfc_stop_poll_mode() throws Exception_NFC {
		Arg_felicalib_nfc_stop_poll_mode afnspm = new Arg_felicalib_nfc_stop_poll_mode();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_stop_poll_mode], afnspm);
		
		System.out.println("felicalib_nfc_stop_poll_mode rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnspm.getLastError()));
		
		if (afnspm.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_stop_poll_mode");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_stop_poll_mode");
		
		return bytRtn != 0;
	}

	/*
	bool felicalib_nfc_thru(
		const unsigned char *command_packet_data,
		unsigned short command_packet_data_length,
		unsigned char *response_packet_data,
		unsigned short *response_packet_data_length
	);
	 */
	class Arg_felicalib_nfc_thru extends Arg_property {
		private @_Const byte[] command_packet_data;
		private short command_packet_data_length;
		private byte[] response_packet_data;
		private short[] response_packet_data_length;
		
		Arg_felicalib_nfc_thru(byte[] command_packet_data, short command_packet_data_length,
				byte[] response_packet_data, short[] response_packet_data_length) {
			this.command_packet_data = command_packet_data;
			this.command_packet_data_length = command_packet_data_length;
			this.response_packet_data = response_packet_data;
			this.response_packet_data_length = response_packet_data_length;
		}
	}
	
	boolean felicalib_nfc_thru(byte[] command_packet_data, short command_packet_data_length,
			byte[] response_packet_data, short[] response_packet_data_length) throws Exception_NFC {
		Arg_felicalib_nfc_thru afnt = new Arg_felicalib_nfc_thru(command_packet_data,
				command_packet_data_length, response_packet_data, response_packet_data_length);

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_thru], afnt);
		
		System.out.println("felicalib_nfc_thru rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnt.getLastError()));
		
		if (afnt.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_thru");
		
		if (bytRtn == 0) {
			int[] error_info = {0, 0};
			felicalib_nfc_get_last_error(error_info);
			if (error_info[0] == H_felica_nfc_library_error.FELICA_NFC_E_DRIVER_ERROR
					&& error_info[1] == 0x00000079) { //ANZX҂^CAEg܂̓R}h^CAEgĂ܂B
				//Ďs\
			}
			else throw new Exception_NFC("felicalib_nfc_thru");
		}
		
		return bytRtn != 0;
	}

	/*
	 bool felicalib_nfc_uninitialize(void);
	 */
	class Arg_felicalib_nfc_uninitialize extends Arg_property {
	}
	
	boolean felicalib_nfc_uninitialize() throws Exception_NFC {
		Arg_felicalib_nfc_uninitialize afnu = new Arg_felicalib_nfc_uninitialize();

		byte bytRtn = JInvoker.callByteProcAddress(lngFncAdrs[IDX_felicalib_nfc_uninitialize], afnu);
		
		System.out.println("felicalib_nfc_uninitialize rtn: " + Byte.toString(bytRtn)
				+ " LastError: " + Integer.toString(afnu.getLastError()));
		
		if (afnu.getLastError() < 0) throw new Exception_NFC("felicalib_nfc_uninitialize");
		if (bytRtn == 0) throw new Exception_NFC("felicalib_nfc_uninitialize");
		
		return bytRtn != 0;
	}

	/*
	HMODULE LoadLibrary(
	  LPCTSTR lpFileName   // W[̃t@C
	);
	 */
	@_CharSet(CHARSET)
	class Arg_LoadLibrary extends Arg_property {
		private @_Const String lpFileName;

		Arg_LoadLibrary(String lpFileName) {
			this.lpFileName = lpFileName;
		}
	}

	/*
	FARPROC GetProcAddress(
	  HMODULE hModule,    // DLL W[̃nh
	  LPCSTR lpProcName   // ֐
	);
	 */
	@_CharSet(Arg.ANSI)
	class Arg_GetProcAddress extends Arg_property {
		private long hModule;
		private @_Const @_Ansi String lpProcName;

		Arg_GetProcAddress(long hModule, String lpProcName) {
			this.hModule = hModule;
			this.lpProcName = lpProcName;
		}
	}
	
	/*
	BOOL FreeLibrary(
		HMODULE hModule   // DLL W[̃nh
	);
	 */
	class Arg_FreeLibrary extends Arg_property {
		private long hModule;

		Arg_FreeLibrary(long hModule) {
			this.hModule = hModule;
		}
	}
}